var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var TSUI;
(function (TSUI) {
    (function (UI) {
        var NotificationBottomOffset = 0;
        UI.VisibleNotifications = [];

        var Notification = (function (_super) {
            __extends(Notification, _super);
            function Notification(text) {
                _super.call(this);
                this._HideTimeoutRef = -1;
                this._OffsetAdded = 0;
                this._Showing = false;

                this._rootElement.addClass("Notification");
                this._rootElement.css("visibility", "hidden");

                this.OnClose = new TSUI.Events.CloseEvent();

                this.CloseButton = new UI.Button();
                this.CloseButton.AddClass("NotificationCloseButton");
                this.CloseButton.Text("X");
                this.Children.Add(this.CloseButton);

                this._TextLabel = new UI.Label();
                this._TextLabel.RelativeLayoutOn();
                this.Children.Add(this._TextLabel);

                this.Text(text);

                this.CloseButton.OnClick.Attach(new TSUI.Events.ClickEventHandler(this._CloseButton_Click, this));
            }
            Notification.prototype.Text = function (value) {
                if (typeof value === "undefined") { value = null; }
                return this._TextLabel.Text(value);
            };

            Notification.prototype._CloseButton_Click = function (eventArgs) {
                var _this = this;
                this.Hide();
            };

            Notification.prototype.Show = function (callback, animator) {
                if (typeof callback === "undefined") { callback = null; }
                if (typeof animator === "undefined") { animator = new TSUI.Animation.NotificationAnimator(); }
                if (this._HideTimeoutRef !== -1) {
                    clearTimeout(this._HideTimeoutRef);
                    this._HideTimeoutRef = -1;
                }

                if (!this.Visible() && !this._Showing) {
                    this._Showing = true;
                    var _this = this;
                    this.Bottom(new UI.CSSNumber(NotificationBottomOffset));
                    UI.VisibleNotifications.push(this);
                    _super.prototype.Show.call(this, function () {
                        _this._Showing = false;
                        if (callback !== null)
                            callback();
                    }, animator);
                    NotificationBottomOffset += (this._OffsetAdded = this.AnimationElement().outerHeight());
                } else if (callback !== null) {
                    callback();
                }
            };
            Notification.prototype.ShowFor = function (seconds, callback, animator) {
                if (typeof callback === "undefined") { callback = null; }
                var _this = this;
                this.Show(function () {
                    if (this._HideTimeoutRef !== -1) {
                        clearTimeout(this._HideTimeoutRef);
                        this._HideTimeoutRef = -1;
                    }

                    _this._HideTimeoutRef = setTimeout(function () {
                        _this.Hide(null, animator);
                    }, seconds * 1000);

                    if (callback !== null) {
                        callback();
                    }
                }, animator);
            };
            Notification.prototype.Hide = function (callback, animator) {
                if (typeof callback === "undefined") { callback = null; }
                if (typeof animator === "undefined") { animator = new TSUI.Animation.NotificationAnimator(); }
                var _this = this;
                NotificationBottomOffset -= this._OffsetAdded;
                UI.VisibleNotifications.splice(UI.VisibleNotifications.indexOf(this), 1);
                Notification.RestackAll();
                this._OffsetAdded = 0;
                _super.prototype.Hide.call(this, function () {
                    _this.OnClose.Invoke(new TSUI.Events.CloseEventArgs(_this));
                    if (callback !== null) {
                        callback();
                    }
                }, animator);
            };

            Notification.prototype._Restack = function () {
                new TSUI.Animation.NotificationRestackAnimator().AnimateRestack(this, NotificationBottomOffset);
                NotificationBottomOffset += (this._OffsetAdded = this.AnimationElement().outerHeight());
            };

            Notification.RestackAll = function () {
                NotificationBottomOffset = 0;
                for (var i = 0; i < UI.VisibleNotifications.length; i++) {
                    UI.VisibleNotifications[i]._Restack();
                }
            };
            return Notification;
        })(UI.Control);
        UI.Notification = Notification;
    })(TSUI.UI || (TSUI.UI = {}));
    var UI = TSUI.UI;
})(TSUI || (TSUI = {}));
